// EditNumAndPoint.cpp : implementation file
//

#include "stdafx.h"
#include "EditNumAndPoint.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditNumAndPoint

CEditNumAndPoint::CEditNumAndPoint()
{
	bThe1st_WM_GETDLGCODE=true;
	ccPointSymb='.';//  IP
	bMainStringHasToBeReadFromWin=false;
}


CEditNumAndPoint::~CEditNumAndPoint()
{
}


BEGIN_MESSAGE_MAP(CEditNumAndPoint, CEdit)
	//{{AFX_MSG_MAP(CEditNumAndPoint)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditNumAndPoint message handlers

LRESULT CEditNumAndPoint::DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	switch(message)
	{
		case WM_PASTE:
		{
			bMainStringHasToBeReadFromWin=true;
			CEdit::DefWindowProc(message, wParam, lParam);
			GetWindowText(m_csMainString);
			CorrectAndShowMainString();

			return 0;
		}
		break;

		case WM_KEYDOWN:
		{
			
			switch(wParam)
			{
				case VK_BACK:
				{
					return 0;
				}
				break;

				case VK_END:
				case VK_HOME:
				case VK_LEFT:
				case VK_RIGHT:
				{
					CEdit::DefWindowProc(message, wParam, lParam);
					return 0;
				}
				break;
			}

			bMainStringHasToBeReadFromWin=true;
			CEdit::DefWindowProc(message, wParam, lParam);
			GetWindowText(m_csMainString);
			CorrectAndShowMainString();
			return 0;

		}
		break;


		case WM_CHAR:
		{
			int iii=1;
			switch(wParam)
			{
				case ',':
				case '<':
				case '':
				case '':
				case '':
				case '':
				case '>':
				case '?':
				case '/':
				case '.'://  ccPointSymb !!!
				{
					wParam=ccPointSymb;
					//return 0;
				}
				break;

				case '1':
				case '2':
				case '3':
				case '4':
				case '5':
				case '6':
				case '7':
				case '8':
				case '9':
				case '0':
				case VK_BACK:
				{
					int iii=1;
					//return 0;
				}
				break;

				default:
				{
					return 0;
				}
			}

			bMainStringHasToBeReadFromWin=true;
			CEdit::DefWindowProc(message, wParam, lParam);
			GetWindowText(m_csMainString);
			CorrectAndShowMainString();
			return 0;

		}
		break;

		case WM_GETDLGCODE:
		{
			//    ?
			if(bThe1st_WM_GETDLGCODE)
			{
				// 
				bThe1st_WM_GETDLGCODE=false;
				m_csMainString="";
				CorrectAndShowMainString();
			}
		}
		break;

		case WM_SETTEXT:
		{
			bMainStringHasToBeReadFromWin=true;
			m_csMainString=(const char*)lParam;
			CorrectAndShowMainString();
			return 0;
			//return CEdit::DefWindowProc(message, wParam, lParam);
		}
		break;

	}


	return CEdit::DefWindowProc(message, wParam, lParam);
}

void CEditNumAndPoint::CorrectAndShowMainString(double* pVal)
{

	if(pVal)
	{
		m_csMainString.Format("%u",(DWORD)(*pVal));
	}

	//    bMainStringHasToBeReadFromWin  !!!


	// 
	bThe1st_WM_GETDLGCODE=false;

	//   m_csMainString

	//,     .
	//  *.*.*.*(...) ,  * -    
	m_csMainString.Replace(',',ccPointSymb);
	m_csMainString.Replace('<',ccPointSymb);
	m_csMainString.Replace('',ccPointSymb);
	m_csMainString.Replace('',ccPointSymb);
	m_csMainString.Replace('',ccPointSymb);
	m_csMainString.Replace('',ccPointSymb);
	m_csMainString.Replace('>',ccPointSymb);
	m_csMainString.Replace('?',ccPointSymb);
	m_csMainString.Replace('/',ccPointSymb);

	m_csMainString=m_csMainString.SpanIncluding("1234567890.");

	//  
	DWORD dwdsel;
	dwdsel=GetSel();
	CEdit::DefWindowProc(WM_SETTEXT,0,(UINT)(const char*)m_csMainString);
	SetSel(dwdsel);
}


// ,   0.1.2.3.4 ....
int CEditNumAndPoint::GetAnNumber(int afterPointN)
{
	if(bMainStringHasToBeReadFromWin)
	{
		bMainStringHasToBeReadFromWin=false;
		GetWindowText(m_csMainString);
	}

	int res=0;

	const char* pStr=(const char*)m_csMainString;

	const char* pF=pStr;
	for(int i=0;i<afterPointN;i++)
	{
		pF=strchr(pF,ccPointSymb);
		if(!pF)break;
		pF++;
	}

	if(pF && *pF)
	{
		res=atoi(pF);
	}

	return res;
}


// double-
double CEditNumAndPoint::GetDoubleNumber()
{
	if(bMainStringHasToBeReadFromWin)
	{
		bMainStringHasToBeReadFromWin=false;
		GetWindowText(m_csMainString);
	}

	double dTemp=atof((const char*)m_csMainString);
	return dTemp;
}

